/* vifm
 * Copyright (C) 2001 Ken Steen.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef __STATUS_H__
#define __STATUS_H__

#include <sys/stat.h>

#include <inttypes.h>

#include "../config.h"
#include "tree.h"

typedef struct
{
	int need_redraw;
	volatile int freeze;
	int is_updir;
	int last_char;
	char updir_file[NAME_MAX];
	int is_console;
	uint32_t config_crc32;
	int search;
	int save_msg;
	int use_register;
	int use_input_bar;
	int curr_register;
	int register_saved;
	int number_of_windows;
	int view;
	int show_full;
	int setting_change;
	int skip_history;
	int vifm_started; /* 0 - no TUI, 1 - TUI, 2 - all */

	int errmsg_shown; /* 0 - none, 1 - error, 2 - query */

	tree_t dirsize_cache;

#ifdef HAVE_LIBGTK
	int gtk_available; /* for mimetype detection */
#endif
}Status;

extern Status curr_stats;

void init_status(void);

#endif

/* vim: set tabstop=2 softtabstop=2 shiftwidth=2 noexpandtab cinoptions-=(0 : */
